extends ../layouts/navbar
include ../components/successerrorbox

block content
    h1 Question Management (#{ginfo.name})
    +successerror(sucmsg, errmsg)

    .btn-group(role="group", aria-label="Toolbar").mb-2
        a#backBtn.btn.btn-danger(href=`/course/info/${courseid}/${quizid}/overview?edit=1`) Go Back
        button#addSection.btn.btn-secondary(type="button", data-toggle="modal", data-target="#addSectionModal") Add Section
        button#addQuestion.btn.btn-secondary(type="button") Add Questions

    // Sections list here eventually
    each sec,i in sections.list
        .card.quiz-sections(id=`section-cust-${i}`, data-sectionid=i).mb-2
            .card-header.quiz-section-title= sec.name
            .card-body
                .btn-group(role="group", aria-label="Toolbar").mb-2
                    button.btn.btn-secondary(type="button").update-section-opts Section Options
                    button.btn.btn-secondary(type="button").update-section-lang Update Languages (Code)
                    if i !== 0
                        a.btn.btn-secondary(href=`/course/info/${courseid}/${quizid}/questions/reorder/${i}/${i-1}`)
                            i.fa.fa-arrow-up
                    if i !== sections.list.length - 1
                        a.btn.btn-secondary(href=`/course/info/${courseid}/${quizid}/questions/reorder/${i}/${i+1}`)
                            i.fa.fa-arrow-down
                    button.btn.btn-danger.section-delete-btn(type="button", data-section=sec.name, data-sectionid=i) Delete Section
                unless sec.noofqns !== -1
                    button.btn.btn-outline-dark.section-info(type="button", disabled=true, aria-disabled=true, data-qncount=-1).disabled.float-right= `All section questions in quiz`
                else
                    button.btn.btn-outline-dark.section-info(type="button", disabled=true, aria-disabled=true, data-qncount=sec.noofqns).disabled.float-right= `${sec.noofqns} section questions in quiz`


                ul.list-group.quiz-section-list(data-section=i)
                    each qn in sec.questions
                        li.list-group-item.draggable.w-100(data-idval=qn.id)
                            div
                                button.btn.btn-danger.float-right.align-middle.question-delete-btn(type="button", data-idval=qn.id, data-sectionname=sec.name, data-section=i)
                                    i.fa.fa-trash
                                h4.card-title= qn.name
                                div= `Bank: ${qn.bankname} | Type: ${qn.typeName} | Score: ${qn.score}`
                                if qn.opt
                                    - let opts = qn.opt.split('|')
                                    - let langName = (parseInt(opts[1]) === 0) ? "Easy" : (parseInt(opts[1]) === 1) ? "Medium" : "Hard"
                                    span= `Languages: ${opts[0]} | Difficulty: ${langName}`

    // Default list here (for every other questions)
    - var def = sections.def
    .card.quiz-sections.mt-3#section-Default(data-sectionid="def")
        .card-header.quiz-section-title Default Section
        .card-body
            .btn-group(role="group", aria-label="Toolbar").mb-2
                button.btn.btn-secondary(type="button").update-section-opts Section Options
                button.btn.btn-secondary(type="button").update-section-lang Update Languages (Code)
            unless def.noofqns !== -1
                button.btn.btn-outline-dark.section-info(type="button", disabled=true, aria-disabled=true, data-qncount=-1).disabled.float-right= `All section questions in quiz`
            else
                button.btn.btn-outline-dark.section-info(type="button", disabled=true, aria-disabled=true, data-qncount=def.noofqns).disabled.float-right= `${def.noofqns} section questions in quiz`
            ul.list-group.quiz-section-list(data-section=def.name)
                each qn in def.questions
                    li.list-group-item.draggable.w-100(data-idval=qn.id)
                        div
                            button.btn.btn-danger.float-right.align-middle.question-delete-btn(type="button", data-idval=qn.id, data-section=def.name)
                                i.fa.fa-trash
                            h4.card-title= qn.name
                            div= `Bank: ${qn.bankname} | Type: ${qn.typeName} | Score: ${qn.score}`
                            if qn.opt
                                - let opts = qn.opt.split('|')
                                - let langName = (parseInt(opts[1]) === 0) ? "Easy" : (parseInt(opts[1]) === 1) ? "Medium" : "Hard"
                                span= `Languages: ${opts[0]} | Difficulty: ${langName}`

    // Update languages dialog
    .modal.fade#updateLangModal(role="dialog", aria-hidden="true", tabindex="-1", aria-labelledby="updateLangModalTitle")
        .modal-dialog.modal-dialog-centered(role="document")
            .modal-content
                .modal-header
                    h5.modal-title#updateLangModalTitle Update Section Allowed Coding Languages
                    button.close(type="button", data-dismiss="modal", aria-label="Close")
                        span(aria-hidden="true") &times;
                .modal-body
                    input(type='hidden', name='sectionid')#sidLang
                    .div#codelangModal.collapse
                        .code-opts
                    small.text-danger.text-hide#codelangErr Please select at least 1 language
                .modal-footer
                    button.btn.btn-secondary(type="button", data-dismiss="modal") Close
                    button.btn.btn-primary(type="button")#updateLangBtn Update Languages
        script.
            $("#updateLangBtn").click(() => {
                let data = {sectionId: $("#sidLang").val(), selOptions: []};
                let modal = $("#updateLangModal");
                let cle = $("#codelangErr");
                modal.find('.code-opts input:checked').each(function (i, v) {
                    data.selOptions.push($(v).val());
                });
                if (data.selOptions.length <= 0) {
                    cle.removeClass('text-hide');
                    return;
                }
                cle.addClass('text-hide');
                $.ajax({
                    url: `/course/info/#{courseid}/#{quizid}/questions/updateLang`,
                    dataType: 'json',
                    type: 'post',
                    data: data,
                    async: true,
                    success: (obj) => {
                        if (obj.success) location.reload();
                    }
                });
            });

    // Update section options dialog
    .modal.fade#updateOptsModal(role="dialog", aria-hidden="true", tabindex="-1", aria-labelledby="updateOptsModalTitle")
        .modal-dialog.modal-dialog-centered(role="document")
            .modal-content
                .modal-header
                    h5.modal-title#updateOptsModalTitle Update Section Options
                    button.close(type="button", data-dismiss="modal", aria-label="Close")
                        span(aria-hidden="true") &times;
                .modal-body
                    form#addSecOptsForm
                        input.form-control#secOptId(type='hidden', name='section', value=0)
                        .form-group.required
                            label(for='secQns') Number of questions to randomly pick in section for quiz
                            input.form-control#secQns(type='number', placeholder='Number of Questions', required=true, name='qnPerSection', min=-1, max=0, value=0)
                            small#secQnsHelp.form-text.text-muted Obtaining Accepted Number Range for input
                            div.invalid-feedback#secQnsFeedback Obtaining Feedback
                .modal-footer
                    button.btn.btn-secondary(type="button", data-dismiss="modal") Close
                    button.btn.btn-primary(type="button")#updateOptsBtn Update Options
        script.
            $("#updateOptsBtn").click(() => {
                let sq = $("#secQns");
                let data = {sectionId: $("#secOptId").val(), numQns: sq.val() };
                let max = sq.attr('max');
                sq.removeClass("is-valid is-invalid");
                let isInputValid = (data.numQns && data.numQns >= -1 && data.numQns <= max);
                sq.addClass((isInputValid) ? "is-valid" : "is-invalid");
                if (!isInputValid) return;
                $.ajax({
                    url: `/course/info/#{courseid}/#{quizid}/questions/updateOpts`,
                    dataType: 'json',
                    type: 'post',
                    data: data,
                    async: true,
                    success: (obj) => {
                        if (obj.success) location.reload();
                    }
                });
            });


    // Add Sections dialog
    .modal.fade#addSectionModal(role="dialog", aria-hidden="true", tabindex="-1", aria-labelledby="addSectionModalTitle")
        .modal-dialog.modal-dialog-centered(role="document")
            .modal-content
                .modal-header
                    h5.modal-title#addSectionModalTitle Add New Section
                    button.close(type="button", data-dismiss="modal", aria-label="Close")
                        span(aria-hidden="true") &times;
                .modal-body
                    form#addSectionForm
                        .form-group.required
                            label(for='sectionName') Section Name
                            input.form-control#sectionName(type='text', placeholder='Section Name', required=true, name='sectionName')
                            div.invalid-feedback#sectionFeedback Please fill in a Section Name
                .modal-footer
                    button.btn.btn-secondary(type="button", data-dismiss="modal") Close
                    button.btn.btn-primary(type="button")#addSectionBtn Add
        script.
            $("#addSectionBtn").click(() => {
                let data = $("#addSectionForm").serializeArray();
                let sn = $("#sectionName");
                let sf = $("#sectionFeedback");
                let gothrough = false;
                for (let d of data) {
                    if (d.name === "sectionName") {
                        sf.text("Please fill in a Section Name")
                        sn.removeClass("is-valid is-invalid");
                        sn.addClass((d.value) ? "is-valid" : "is-invalid");
                        gothrough = (d.value);
                        break;
                    }
                }
                if (!gothrough) {return;}
                // Add section and refresh page
                $.ajax({
                    url: `/course/info/#{courseid}/#{quizid}/questions/addSection`,
                    dataType: 'json',
                    type: 'post',
                    data: data,
                    async: true,
                    success: (obj) => {
                        if (obj.success) location.reload();
                        else {
                            sf.text("Section already exists in Quiz");
                            sn.addClass("is-invalid");
                        }
                    }
                });
            });


    // Add Questions section
    .backdrop
    .quiz-question-add#addQn
        h1 Add Questions
        .form-group
            label(for='questionBank') Select Question Bank
            select.form-control#questionBank(required=true, name='questionBank')
                option(hidden=true, disabled=true, selected=true, value="") Select a Question Bank
                each bank in banks
                    option(value=bank.id)= bank.name

        h3 Select Questions to add
        span.small You can select/deselect questions by clicking on them in the list
        table#qnSelTable.table.w-100

        .div#codelang.collapse
            h3 Select Languages
            .code-opts

        .div.mt-3
            h3 Select Section to add to
            select.form-control#sectionSel(required=true, name='questionBank')
                option(value="def", selected=true) Default Section
                each sec,i in sections.list
                    option(value=`sec-${i}`)=sec.name

        .mt-3
            button.btn.btn-primary#addQnBtn(type="button", disabled=true) Add Question
            button.ml-2.btn.btn-danger#cancelAddBtn(type="button") Close

        include ../meta/datatables
        script.
            let aqOverlay = $("#addQn");
            let aqBtn = $("#addQnBtn");
            let collapsible = $("#codelang");
            let backdrop = $(".backdrop");
            $(document).ready(() => {
                let table;
                backdrop.hide();
                table = $('#qnSelTable').DataTable({
                    ajax: '/questions/info/-1/data',
                    dom: 'rftip',
                    responsive: true,
                    select: 'multiple',
                    pageLength: 5,
                    deferRender: true,
                    columns: [
                        {title: "#", data: 'pos'},
                        {title: "Question Name", data: 'name'},
                        {title: "Type", data: 'type'},
                        {
                            title: "Difficulty", data: null, render: (data) => {
                                return (data.difficulty) ? data.difficulty : "-";
                            }
                        },
                        {title: "Score", data: 'score'},
                    ]
                });

                function getTableString(table) {
                    let selData = table.rows({selected: true}).toArray()[0];
                    let inData = [];
                    for (let i of selData) {
                        inData.push(table.rows(i).data().toArray()[0].id);
                    }
                    return inData.join(",");
                }

                let timeoutVal = null;
                function updateLangOptSelection() {
                    let selVal = $("#questionBank").val();
                    let csvStr = getTableString(table);
                    $.ajax({
                        url: `/questions/info/${selVal}/codecommonlang?qnid=${csvStr}`,
                        dataType: 'json',
                        type: 'get',
                        async: true,
                        success: (obj) => {
                            updateCodeLang(obj, collapsible, aqBtn);
                        }
                    });
                }

                table.on('draw', () => MathJax.typesetPromise());
                table.on('deselect', () => {
                    let selectedRows = table.rows({selected: true}).count();
                    if (selectedRows.length > 0) return;
                    timeoutVal = setTimeout(() => {updateLangOptSelection();}, 100);
                })
                table.on('select', () => {
                    let selectedRows = table.rows({selected: true}).count();
                    aqBtn.prop('disabled', (selectedRows.length <= 0) ? 'true' : '');
                    if (selectedRows.length <= 0) return;
                    if (timeoutVal !== null) {clearTimeout(timeoutVal);timeoutVal = null;}
                    updateLangOptSelection();
                });
                aqBtn.click(() => {
                    let section = $("#sectionSel").val();
                    let questions = getTableString(table);
                    let data = {section: section, qid: questions};
                    let selOptions = [];
                    $('.code-opts input:checked').each(function (i, v) {
                        selOptions.push($(v).val());
                    });
                    data.languages = selOptions;
                    let hasData = collapsible.hasClass("show");
                    if (data.qid.length <= 0) {
                        alert("Please select questions to add");
                        return;
                    }
                    if (hasData && data.languages.length <= 0) {
                        alert("Please select languages to add");
                        return;
                    }
                    $.ajax({
                        url: `/course/info/#{courseid}/#{quizid}/questions/add`,
                        dataType: 'json',
                        type: 'post',
                        data: data,
                        async: true,
                        success: (obj) => {
                            if (obj.success) location.reload();
                        }
                    });
                });
                $("#questionBank").on('change', (e) => table.ajax.url(`/questions/info/${e.target.value}/data`).load());
            });
            $("#cancelAddBtn").click(() => {
                aqOverlay.removeClass('popout');
                backdrop.hide();
            });


        script(src="https://cdn.jsdelivr.net/npm/@shopify/draggable@1.0.0-beta.12/lib/sortable.js")
        script.
            function updateCodeLang(langObj, element, button) {
                let codeOptions = element.find(".code-opts");
                element.collapse((langObj.hasCL) ? 'show' : 'hide');
                if (!langObj.hasCL) {
                    button.prop('disabled', '');
                    return;
                }
                codeOptions.empty();
                for (let cl of langObj.languages) {
                    let toAppend = `<div class='form-check form-check-inline'><input class='form-check-input' type='checkbox' id='lang-${cl.key}' value='${cl.key}'>` +
                        `<label class='form-check-label' for='lang-${cl.key}'>${cl.name}</label></div>`;
                    codeOptions.append(toAppend);
                }
                element.collapse((langObj.hasCL) ? 'show' : 'hide');
                if (langObj.languages.length <= 0) codeOptions.append("<div class='text-danger'>No Common Languages between questions</div>")
                button.prop('disabled', (langObj.languages.length <= 0) ? 'true' : '');
            }

            const sortable = new Sortable.default(document.querySelectorAll('ul'), {
                draggable: 'li.draggable',
                distance: 10
            });

            sortable.on('sortable:stop', (e) => {
                let newSectionId = $(e.newContainer).data("section");
                let oldSectionId = $(e.oldContainer).data("section");
                let data = {oldSection: oldSectionId, newSection: newSectionId, oldIndex: e.data.oldIndex, newIndex: e.data.newIndex};
                $.ajax({
                    url: `/course/info/#{courseid}/#{quizid}/questions/moveQuestions`,
                    dataType: 'json',
                    type: 'post',
                    data: data,
                    async: true,
                    success: (obj) => {
                        if (!obj.success) location.reload(); // Reload if invalid
                    }
                });
            });

            $("#addQuestion").click(() => {
                aqOverlay.addClass('popout');
                backdrop.show();
            });
            $(".question-delete-btn").click((e) => {
                let ct = $(e.currentTarget);
                let deleteId = ct.data("idval");
                let delSection = ct.data("section");
                $.ajax({
                    url: `/course/info/#{courseid}/#{quizid}/questions/delete/${delSection}/${deleteId}`,
                    type: 'delete',
                    async: true,
                    success: (obj) => {
                        if (obj.success) ct.closest("li").remove();
                    }
                });
            });
            $(".section-delete-btn").click((e) => {
                let ct = $(e.currentTarget);
                let deleteId = ct.data("section");
                if (confirm(`Are you sure you want to delete this section "${deleteId}"? The section and the questions within will be removed!`)) {
                    let delSection = ct.data("sectionid");
                    $.ajax({
                        url: `/course/info/#{courseid}/#{quizid}/questions/delete/${delSection}`,
                        type: 'delete',
                        async: true,
                        success: (obj) => {
                            if (obj.success) location.reload();
                        }
                    });
                }
            });
            $(".update-section-lang").click((e) => {
                let ct = $(e.currentTarget);
                let questions = ct.closest(".quiz-sections").find("li");
                let qncsv = "";
                let langsel = $('#codelangModal');
                let btnCfm = $('#updateLangBtn');
                let sidval = ct.closest(".quiz-sections").data('sectionid');
                questions.each((index) => qncsv += $(questions[index]).data('idval') + ",");
                if (!qncsv) return;
                qncsv = qncsv.replace(/,\s*$/, "");
                $.ajax({
                    url: `/questions/codecommonlang?qnid=${qncsv}`,
                    dataType: 'json',
                    type: 'get',
                    async: true,
                    success: (obj) => {
                        updateCodeLang(obj, langsel, btnCfm);
                        $('#sidLang').val(sidval);
                        $("#codelangErr").addClass('text-hide');
                        $('#updateLangModal').modal();
                    }
                });
            });
            $(".update-section-opts").click((e) => {
                let ct = $(e.currentTarget);
                let numqnspersection = ct.closest(".card-body").find(".section-info").data('qncount');
                let questionCount = ct.closest(".quiz-sections").find("li").length;
                let sq = $('#secQns');
                $('#secQnsHelp').text(`Accepted Number Range: -1 to ${questionCount}`);
                $('#secQnsFeedback').text(`Please fill in a value between -1 and ${questionCount}`);
                sq.attr('max', questionCount);
                sq.val(numqnspersection);
                sq.removeClass("is-valid is-invalid");

                $('#secOptId').val(ct.closest(".quiz-sections").data('sectionid'));

                $('#updateOptsModal').modal();
            });


